;******************************************************************************
;
;
;        The Minus4 project - Copyright (c) Mike Dailly 1996,97,98
;
;
; This source and the Minus4 project remains the copyright of Mike Dailly, 
; but can be freely used and changed for NON-Commercial purposes. 
;
;								 Keep emulators free!
;
; Remember if you add or change anything, you MUST send a copy
; complete with source to me at mike@scotch.demon.co.uk
; If its just a bug fix, then just send the changed file, with a comment
; telling me WHERE you fixed and WHAT you fixed.
;
; 
;									 		    
;		     Plus 4 Screen drawing stuff
;											 
;                                                                          
;                                                                          
;                                                                          
;******************************************************************************

wcstack	equ	1

	.486
IFDEF	WCSTACK
	extrn  ScaleScreen:dword;
	extrn	 Screen2:dword
	extrn	 VidBase2:dword
	extrn  Frame:dword
	extrn	 ScreenIndexArray:dword		; Screen index array...
	extrn	 ScreenData:dword
	extrn	 pScreenDataAddress:dword
	extrn	 ROMS:dword				; array of roms
	extrn  ROM:dword
	extrn	 ROMINF:dword
	extrn	 Memory:dword
	extrn  mouse:word
	extrn  moved:word
	extrn  xx:word
	extrn  yy:word
	extrn  but:word
	extrn  Screen:dword
	extrn  ScreenTable:dword
	extrn	 Memory:dword
	extrn	 CharAddress:dword
        extrn  FlashCount:dword

	extrn	 CharAttribute:byte;				// read on the LAST line of the previous character
	extrn	 CharNumber:byte;					// read on the FIRST line of the character
        extrn  TextColour:byte
	
	.MODEL  FLAT
ENDIF

IFDEF	WCREG
	.MODEL  FLAT,C
ENDIF

VidBase	=   0A0000h
ScrSeg	=   0B8000h
Xsize   =   368
Ysize   =   240
XYsize  =   Xsize*Ysize
	    

INT_ST  struct
R_EDI   dword   0
R_ESI   dword   0
R_EBP   dword   0
R_reserved      dword   0
R_EBX   dword   0
R_EDX   dword   0
R_ECX   dword   0
R_EAX   dword   0
R_Flags word    0
R_ES    word    0
R_DS    word    0
R_FS    word    0
R_GS    word    0
R_IP    word    0
R_CS    word    0
R_SP    word    0
R_SS    word    0
INT_ST  ENDS

tScreenInfo	struct
	blank			dword	0
	bmm			dword	0
	multicol		dword	0
	Invert		dword	0
	CharSet		dword	0
	BitMap		dword	0
	ScrollX		dword	0
	ScrollY		dword	0
	ScreenAddress	dword	0
	Cursor		dword 0
	col0			byte	0
	col1			byte	0
	col2			byte	0
	col3			byte	0
	col4			byte	0
tScreenInfo ends


	.DATA
IFDEF	WCREG
	extrn  ScaleScreen:dword;
	extrn  Frame:dword
	extrn	 ScreenIndexArray:dword		; Screen index array...
	extrn	 ScreenData:dword
	extrn	 pScreenDataAddress:dword
	extrn	 ROMS:dword			; array of roms
	extrn  ROM:dword
	extrn	 ROMINF:dword
	extrn	 Memory:dword
	extrn  mouse:word
	extrn  moved:word
	extrn  xx:word
	extrn  yy:word
	extrn  but:word
	extrn  Screen:dword
	extrn  ScreenTable:dword
	extrn	 Memory:dword
	extrn	 CharAddress:dword

        extrn  FlashCount:dword
	extrn	 CharAttribute:byte;				// read on the LAST line of the previous character
	extrn	 CharNumber:byte;					// read on the FIRST line of the character
	extrn	 Screen2:dword
	extrn	 VidBase2:dword
        extrn  TextColour:byte
			
ENDIF
Temp	dword	0
Ints	INT_ST	<>

chars	dword	0
xscr	dword	0
yscr	dword	0
xloop	dword	0
yloop	dword	0
inv	dword	0
mcm	dword 0
ScrData	dword 0
colour0	byte  0
colour1	byte  0
colour2	byte  0
colour3	byte  0
colour4	byte  0
multitable	byte	0,0,0,0
                                             
HexTable      db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,1,2,3,4,5,6,7,8,9,0,0,0,0,0,0
              db          0,10,11,12,13,14,15,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,10,11,12,13,14,15,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
              db          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        public      Tone
; The TED chip's middle "c" tone
Tone		db		063h,01Ah,00Ah,016h,034h,03Ah,02Ah,026h,032h,03Bh,03Bh,03Fh,047h,04Bh,055h,069h
		db		07Bh,083h,0A6h,0EFh,0FFh,0E6h,0C7h,0C7h,0D8h,0DAh,0CBh,0C5h,0C4h,0BFh,0B7h,0B3h
		db		0A8h,094h,081h,07Ah,050h,010h,00Bh,01Ch,039h,035h,025h,027h,035h,03Ah,03Ch,041h
		db		049h,04Ch,059h,06Eh,080h,088h,0B9h,0FFh,0FFh,0E0h,0C8h,0CDh,0DCh,0D8h,0CBh,0C7h
		db		0C5h,0BFh,0B9h,0B5h,0A6h,090h,081h,079h,042h,00Dh,00Bh,023h,03Bh,034h,027h,02Bh
		db		037h,03Ch,03Dh,044h,04Ah,04Fh,05Eh,073h,081h,08Ch,0CDh,0FDh,0F9h,0D9h,0C5h,0D2h
		db		0DFh,0D7h,0CAh,0C7h,0C6h,0BEh,0B9h,0B4h,0A4h,08Eh,080h,072h,030h,009h,010h,02Eh
		db		03Dh,031h,027h,02Fh,03Bh,03Dh,040h,047h,04Bh,052h,064h,079h,085h,097h,0E0h,0FFh
		db		0F7h,0D3h,0C8h,0D7h,0DEh,0D4h,0CAh,0C8h,0C5h,0BDh,0B8h,0B0h,09Dh,089h,07Fh,06Eh

	public	Palette
; The Plus4 colour palette!
Palette		db		000h,000h,000h,000h,000h,000h,030h,005h,005h,000h,018h,014h,040h,000h,040h,000h
		db		018h,000h,000h,000h,040h,018h,018h,000h,05Ah,02Ah,000h,028h,014h,000h,018h,020h
		db		00Ch,048h,000h,000h,000h,030h,02Ch,000h,000h,040h,000h,000h,040h,000h,018h,000h
		db		000h,000h,000h,024h,024h,024h,060h,008h,008h,000h,038h,034h,058h,008h,05Ch,008h
		db		038h,004h,008h,008h,05Ch,038h,038h,000h,070h,034h,000h,048h,024h,004h,034h,040h
		db		018h,064h,004h,008h,000h,04Ch,044h,00Ch,010h,05Ch,008h,00Ch,05Ch,008h,038h,004h
		db		000h,000h,000h,048h,048h,048h,07Ch,014h,014h,000h,058h,054h,074h,014h,074h,014h
		db		058h,00Ch,014h,018h,074h,058h,058h,004h,084h,048h,004h,064h,038h,010h,04Ch,060h
		db		024h,07Ch,008h,018h,000h,06Ch,05Ch,01Ch,02Ch,074h,018h,01Ch,074h,018h,058h,00Ch
		db		000h,000h,000h,06Ch,06Ch,06Ch,094h,024h,024h,000h,078h,078h,090h,024h,090h,020h
		db		078h,018h,024h,028h,090h,078h,078h,008h,09Ch,058h,004h,084h,050h,024h,068h,080h
		db		034h,094h,010h,028h,000h,088h,078h,034h,04Ch,090h,02Ch,030h,090h,02Ch,078h,01Ch
		db		000h,000h,000h,090h,090h,090h,0B0h,038h,038h,000h,098h,094h,0ACh,03Ch,0ACh,030h
		db		098h,02Ch,03Ch,040h,0ACh,098h,094h,010h,0B4h,070h,008h,0A0h,068h,038h,080h,09Ch
		db		040h,0B0h,018h,03Ch,000h,0A4h,090h,054h,070h,0ACh,048h,04Ch,0ACh,048h,098h,034h
		db		000h,000h,000h,0B4h,0B4h,0B4h,0C8h,050h,050h,000h,0BCh,0B4h,0C4h,058h,0C4h,048h
		db		0BCh,040h,058h,058h,0C4h,0BCh,0B4h,014h,0CCh,084h,00Ch,0C0h,088h,054h,09Ch,0BCh
		db		04Ch,0C8h,024h,058h,000h,0C0h,0ACh,078h,098h,0C4h,068h,06Ch,0C4h,068h,0BCh,04Ch
		db		000h,000h,000h,0D8h,0D8h,0D8h,0E0h,06Ch,06Ch,000h,0DCh,0DCh,0E0h,078h,0E0h,064h
		db		0DCh,05Ch,078h,078h,0E0h,0DCh,0D4h,020h,0E4h,09Ch,014h,0DCh,0A4h,074h,0B4h,0DCh
		db		058h,0E0h,030h,070h,000h,0E0h,0C4h,0A4h,0C0h,0E0h,090h,094h,0E0h,090h,0DCh,06Ch
		db		000h,000h,000h,0FCh,0FCh,0FCh,0FCh,08Ch,08Ch,000h,0FCh,0FCh,0FFh,09Fh,0FFh,080h
		db		0FCh,07Ch,09Ch,09Ch,0FCh,0FCh,0F4h,02Ch,0FCh,0B4h,018h,0FCh,0C8h,09Ch,0D0h,0FFh
		db		065h,0FFh,040h,08Fh,000h,0FFh,0E0h,0D8h,0ECh,0FCh,0BCh,0C0h,0FCh,0BAh,0FFh,090h
		db		000h,000h,000h,000h,000h,000h,030h,005h,005h,000h,018h,014h,040h,000h,040h,000h
		db		018h,000h,000h,000h,040h,018h,018h,000h,05Ah,02Ah,000h,028h,014h,000h,018h,020h
		db		00Ch,048h,000h,000h,000h,030h,02Ch,000h,000h,040h,000h,000h,040h,000h,018h,000h
		db		000h,000h,000h,024h,024h,024h,060h,008h,008h,000h,038h,034h,058h,008h,05Ch,008h
		db		038h,004h,008h,008h,05Ch,038h,038h,000h,070h,034h,000h,048h,024h,004h,034h,040h
		db		018h,064h,004h,008h,000h,04Ch,044h,00Ch,010h,05Ch,008h,00Ch,05Ch,008h,038h,004h
		db		000h,000h,000h,048h,048h,048h,07Ch,014h,014h,000h,058h,054h,074h,014h,074h,014h
		db		058h,00Ch,014h,018h,074h,058h,058h,004h,084h,048h,004h,064h,038h,010h,04Ch,060h
		db		024h,07Ch,008h,018h,000h,06Ch,05Ch,01Ch,02Ch,074h,018h,01Ch,074h,018h,058h,00Ch
		db		000h,000h,000h,06Ch,06Ch,06Ch,094h,024h,024h,000h,078h,078h,090h,024h,090h,020h
		db		078h,018h,024h,028h,090h,078h,078h,008h,09Ch,058h,004h,084h,050h,024h,068h,080h
		db		034h,094h,010h,028h,000h,088h,078h,034h,04Ch,090h,02Ch,030h,090h,02Ch,078h,01Ch
		db		000h,000h,000h,090h,090h,090h,0B0h,038h,038h,000h,098h,094h,0ACh,03Ch,0ACh,030h
		db		098h,02Ch,03Ch,040h,0ACh,098h,094h,010h,0B4h,070h,008h,0A0h,068h,038h,080h,09Ch
		db		040h,0B0h,018h,03Ch,000h,0A4h,090h,054h,070h,0ACh,048h,04Ch,0ACh,048h,098h,034h
		db		000h,000h,000h,0B4h,0B4h,0B4h,0C8h,050h,050h,000h,0BCh,0B4h,0C4h,058h,0C4h,048h
		db		0BCh,040h,058h,058h,0C4h,0BCh,0B4h,014h,0CCh,084h,00Ch,0C0h,088h,054h,09Ch,0BCh
		db		04Ch,0C8h,024h,058h,000h,0C0h,0ACh,078h,098h,0C4h,068h,06Ch,0C4h,068h,0BCh,04Ch
		db		000h,000h,000h,0D8h,0D8h,0D8h,0E0h,06Ch,06Ch,000h,0DCh,0DCh,0E0h,078h,0E0h,064h
		db		0DCh,05Ch,078h,078h,0E0h,0DCh,0D4h,020h,0E4h,09Ch,014h,0DCh,0A4h,074h,0B4h,0DCh
		db		058h,0E0h,030h,070h,000h,0E0h,0C4h,0A4h,0C0h,0E0h,090h,094h,0E0h,090h,0DCh,06Ch
		db		000h,000h,000h,0FCh,0FCh,0FCh,0FCh,08Ch,08Ch,000h,0FCh,0FCh,0FFh,09Fh,0FFh,080h
		db		0FCh,07Ch,09Ch,09Ch,0FCh,0FCh,0F4h,02Ch,0FCh,0B4h,018h,0FCh,0C8h,09Ch,0D0h,0FFh
		db		065h,0FFh,040h,08Fh,000h,0FFh,0E0h,0D8h,0ECh,0FCh,0BCh,0C0h,0FCh,0BAh,0FFh,090h

              include     noise.asm         ; include 64k noise sample :-)
              Public      Noise

              Public	SampStart
		Public	SampEnd
SampStart	label	byte
		;include	Test1.inc
SampEnd		label	byte
			
			.CODE									   
;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    :                                               *
;         *   Function:                                               *
;         *                                                           *
;         *   In   :                                                  *
;         *   Out  :                                                  *
;         *                                                           *
;         *                                                           *
;         *************************************************************
;


Tester	Proc	SYSCALL



	; Body of function

	ret	
Tester	endp




;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    :                                               *
;         *   Function:                                               *
;         *                                                           *
;         *   In   :                                                  *
;         *   Out  :                                                  *
;         *                                                           *
;         *                                                           *
;         *************************************************************
;
	
DrawChar	proc	SYSCALL

	mov	edi, 0B8000h
	mov	al, '@'
	mov	[edi],al

	ret	


DrawChar	endp


;(***************************************************************************)
;(*                                                                         *)
;(* get Mouse (x,y) and button State                                                         *)
;(*                                                                         *)
;(**)
	Public	DoMouse
DoMouse Proc  C USES esi edi ecx eax edx ebx \
        
        cmp	Mouse,0
        jne	@Skips
	mov	ax,3
	int	51      ;$33

        mov	Moved,0
        cmp	cx,xx
        jne	@ItMoved
        cmp	Dx,yy
        je	@NoMove
@ItMoved:       
	mov	Moved,255
@NoMove:        

	mov	xx,cx
	mov	yy,dx
	mov	But,bx
@Skips: ret

DoMouse endp



;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : SetupMouse                                    *
;         *   Function: Checks to see if the mouse is installed       *
;         *             and if so, uses it.                           *
;         *                                                           *
;         *************************************************************
;

	Public	SetupMouse
SetupMouse Proc C USES esi edi ecx eax edx ebx \
           
        mov     Mouse,0
        mov     eax,0   ; Reset Mouse
        Int     51      ; $33


        cmp     ax,65535
        je      @skip

        mov     ax,4    ; Setup Mouse to top left of screen
        mov     cx,0
        mov     dx,0
        int     51      ;$33

        mov     Mouse,255
@Skip:
        ret     
SetupMouse      endp

;****************************************************************************
;
; Display Registers
;
;****************************************************************************

YTable:	dword		0+0b8000h,160+0b8000h,320+0b8000h,480+0b8000h,640+0b8000h,800+0b8000h,960+0b8000h,1120+0b8000h,1280+0b8000h,1440+0b8000h,1600+0b8000h
	dword		1760+0b8000h,1920+0b8000h,2080+0b8000h,2240+0b8000h,2400+0b8000h,2560+0b8000h,2720+0b8000h,2880+0b8000h,3040+0b8000h,3200+0b8000h
	dword		3360+0b8000h,3520+0b8000h,3680+0b8000h,3840+0b8000h,4000+0b8000h,4160+0b8000h,4320+0b8000h,4480+0b8000h,4640+0b8000h

;************************************************************
;                                                           *
;   Name    :                                               *
;   Function:                                               *
;                                                           *
;   In   :                                                  *
;   Out  :                                                  *
;                                                           *
;************************************************************
; Get a HEX value from a string
GetHexChar:
        xor   ecx,ecx
        mov   cl,[esi]
        mov   al,HexTable[ecx]
        shl   al,4
        mov   cl,[esi+1]
        or    al,HexTable[ecx]
        xor   ecx,ecx
        add   esi,2
        ret


	Public	PrintLine
PrintLine proc	C	uses	ecx ebx eax edx esi edi \
			x:dword,y:dword,pMess:dword

        mov	esi,pMess
	mov   ah,TextColour     ; get text colour

	mov	ecx,160
	mov	ebx,y
	imul	ebx,ecx
	add	ebx,x
	add	ebx,x
	add	ebx,ScrSeg
	
PL_lp:	mov	al,[esi]
	inc	esi
	test	al,al
	je	Quit
        cmp   al,27
        je    DoEscapeCode      ; do escape codes!
PrintText:
        mov	[ebx],ax
	add	ebx,2
	jmp	PL_lp

; Codes so far are (where ?? is a HEX value):
;
; [ESC]b?? - set background colour
; [ESC]t?? - set text colour
; [ESC]p?? - set text AND background colour
;
;
DoEscapeCode:
        mov   al,[esi]
        inc   esi
        cmp   al,'b'            ; Background colour?
        jne   CheckTextCol
        call  GetHexChar
        and   ah,0fh
        shl   al,4
        or    ah,al
        jmp   PL_lp             ; now carry on...

CheckTextCol:
        cmp   al,'t'            ; TEXT colour?
        jne   CheckPrintCol
        call  GetHexChar
        and   ah,0f0h
        or    ah,al
        jmp   PL_lp             ; unknown... skip and 

CheckPrintCol:
        cmp   al,'p'            ; TEXT colour?
        jne   PL_lp
        call  GetHexChar
        mov   ah,al

        jmp   PL_lp             ; unknown... skip and 

Quit:
	ret
PrintLine	endp

;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : SetMode                                       *
;         *   Function: Set the screen mode with INT 10h values.      *
;         *             Calls the INT 31h DPMI stuff, which then      *
;         *             calls the int 10h.                            *
;         *                                                           *
;         *   In   : Mode : int (int=32bit dword)                     *
;         *   Out  : none                                             *
;         *                                                           *
;         *                                                           *
;         *************************************************************
;

	Public	SetMode
SetMode         proc    C mode : dword

        mov     edi,offset Ints
        mov     eax,mode
        mov     [edi+R_EAX],eax

        mov     eax,0300h
        mov     ebx,10h
        mov     ecx,0
        int     31h
        ret     

SetMode endp


;************************************************************
;                                                           *
;   Name    : SetMode50                                     *
;   Function: Sets TEXT mode with 50 lines                  *
;                                                           *
;   In   : mode (usually 3)                                 *
;   Out  : none                                             *
;                                                           *
;************************************************************
	Public	SetMode50
SetMode50         proc    C mode : dword
        mov     edi,offset Ints             ; set TEXT mode
        mov     eax,mode
        mov     [edi+R_EAX],eax

        mov     eax,0300h
        mov     ebx,10h
        mov     ecx,0
        int     31h

        mov     edi,offset Ints
        mov     eax,01202h
        mov     [edi+R_EAX],eax             ; select 400 scan lines
        mov     eax,0030h
        mov     [edi+R_EBX],eax
        mov     eax,0300h
        mov     ebx,10h
        mov     ecx,0
        int     31h


        mov     edi,offset Ints             ; set TEXT mode
        mov     eax,mode
        mov     [edi+R_EAX],eax
        mov     eax,0300h
        mov     ebx,10h
        mov     ecx,0
        int     31h

        mov     edi,offset Ints             ; load 8x8 FONT
        mov     eax,1112h
        mov     [edi+R_EAX],eax
        mov     eax,0
        mov     [edi+R_EBX],eax
        mov     eax,0300h
        mov     ebx,10h
        mov     ecx,0
        int     31h
        ret     

SetMode50 endp


;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : CopyScreen                                    *
;         *   Function: Copy over the virtual buffer to the screen    *
;         *                                                           *
;         *   In   : Screen = Buffer address                          *
;         *   Out  : none                                             *
;         *                                                           *
;         *************************************************************
;


	Public	CopyBitMapScreen
CopyBitMapScreen      Proc  C USES esi edi ecx

        mov   eax,ScaleScreen               ; scale screen?
        test  eax,eax
        jne   @Skiper

        mov   esi, Screen
	add	esi, 20+((320+48)*21)
        mov   edi, VidBase
	mov	edx, 200

@lp:    mov   ecx, 10

@lp2:	mov	eax,[esi]
	mov	ebx,[esi+4]
	mov	[edi],eax
	mov	[edi+4],ebx
	mov	eax,[esi+8]
	mov	ebx,[esi+12]
	mov	[edi+8],eax
	mov	[edi+12],ebx
	mov	eax,[esi+16]
	mov	ebx,[esi+20]
	mov	[edi+16],eax
	mov	[edi+20],ebx
	mov	eax,[esi+24]
	mov	ebx,[esi+28]
	mov	[edi+24],eax
	mov	[edi+28],ebx
	add	esi,32
	add	edi,32
	dec	ecx
	jne	@lp2
	
	add	esi,48
	dec	edx
	jne	@lp

        ret

        ;
        ; Print "scaled to fit" screen
        ;
@Skiper:
        mov   esi, Screen
        mov   edi, VidBase
	mov	edx, 200

        
        mov   ecx,0
        mov   ebx,033330000h         ; get DELTA down (0x13333)

@aLoop2:
        push  edx
        push  ecx
        push  ebx
        push  esi

        mov   ecx,0
        mov   ebx,020000000h         ; get DELTA for screen copy L/R(0x12000)
        mov   edx,320

@aLoop1:   
        mov   al,[esi]
        inc   esi                    ; 1.something delta
        add   ecx,ebx
        mov   [edi],al
        adc   esi,0
        inc   edi
        dec   edx
        jne   @aLoop1

        pop   esi
        pop   ebx
        pop   ecx
        pop   edx

        add   ecx,ebx
        jnc   @Skip1
        add   esi,368                ; add another!
@Skip1: add   esi,368
        dec   edx
        jne   @aLoop2

        ret

CopyBitMapScreen      endp


;************************************************************
;                                                           *
;   Name    : CopyXmodeScreen                               *
;   Function: copy the whole screen at once!                *
;                                                           *
;************************************************************

	Public	CopyXmodeScreen
CopyXmodeScreen Proc C uses esi edi eax ecx ebx edx
	mov	dx,03c4h		; Select plane 1
	mov	ax,0102h
        mov   esi,Screen
	
Sclp:
	push	eax
	out	dx,ax


	push	esi
        mov	edi,VidBase
	add	edi,Frame		; offset to Frame base..

	mov	ecx,(((368*240)/4)/8)	; (368*240)/4=22080 (per plane)
X_lp1:	
	mov	al,[esi+8]		; U-Pipe Cache Stall? 
	mov	ah,[esi+12]		; V-Pipe
	shl	eax,16		; U-Pipe
	mov	bl,[esi+24]		; V-Pipe
	mov	bh,[esi+28]		; U-Pipe
	mov	al,[esi]		; V-Pipe
	shl	ebx,16		; U-Pipe
	mov	ah,[esi+4]		; V-Pipe
	mov	bl,[esi+16]		; U-Pipe
	mov	bh,[esi+20]		; V-Pipe
	mov	[edi],eax		; U-Pipe
	add	esi,16*2		; V-Pipe
	mov	[edi+4],ebx		; U-Pipe
	add	edi,(4*2)		; V-Pipe
	dec	ecx			; U-Pipe
	jne	X_lp1			; V-Pipe


	pop	esi
	inc	esi
	pop	eax
	shl	ah,1
	cmp	ah,10h
	jne	Sclp

	
	mov	edx,03c4h		; Select plane 1 again. (TEXT screen needs this)
	mov	eax,0102h
	out	dx,ax			
	ret

CopyXmodeScreen endp


;************************************************************
;                                                           *
;   Name    : CopyXmodeScreen                               *
;   Function: copy the whole screen at once!                *
;                                                           *
;************************************************************

	Public	CopyXmodeScreen
ClearModeXScreen Proc C uses esi edi eax ecx ebx edx
	mov	dx,03c4h		; Select plane 1
	mov	ax,0102h
Sclp_2:
	out	dx,ax

        mov	edi,VidBase
	add	edi,Frame		; offset to Frame base..

        mov   ebx,0
	mov	ecx,40000
X_lp12:	
	mov	[edi],ebx		; U-Pipe
        inc   edi
	dec	ecx			; U-Pipe
	jne	X_lp12		; V-Pipe

	shl	ah,1
	cmp	ah,10h
	jne	Sclp_2

	
	mov	edx,03c4h		; Select plane 1 again. (TEXT screen needs this)
	mov	eax,0102h
	out	dx,ax			
	ret

ClearModeXScreen endp

;************************************************************
;                                                           *
;   Name    : CopyXmodeLine                                 *
;   Function: copy a mode x line. allow for video RAM cache *
;             gives a speed up on most cards (I think)      *
;                                                           *
;   In   : Screen2 = pointer to data                        *
;          VidBase2= offset from VidBase to start copying   *
;   Out  : none                                             *
;                                                           *
;************************************************************

	Public	CopyXmodeLine
CopyXmodeLine Proc C uses esi edi eax ecx ebx edx
	mov	dx,03c4h		; Select plane 1
	mov	ax,0102h
        mov   esi,Screen2		; get base to draw FROM
	
@Sclp:
	push	eax
	out	dx,ax


	push	esi
        mov	edi,VidBase		; get current pointer
        add	edi,VidBase2	; get current pointer

	mov	ecx,((368/4)/8)	; copy 1 line
@X_lp1:	
	mov	al,[esi+8]		; U-Pipe Cache Stall? 
	mov	ah,[esi+12]		; V-Pipe
	shl	eax,16		; U-Pipe
	mov	bl,[esi+24]		; V-Pipe
	mov	bh,[esi+28]		; U-Pipe
	mov	al,[esi]		; V-Pipe
	shl	ebx,16		; U-Pipe
	mov	ah,[esi+4]		; V-Pipe
	mov	bl,[esi+16]		; U-Pipe
	mov	bh,[esi+20]		; V-Pipe
	mov	[edi],eax		; U-Pipe
	add	esi,16*2		; V-Pipe
	mov	[edi+4],ebx		; U-Pipe
	add	edi,4*2		; V-Pipe
	dec	ecx			; U-Pipe
	jne	@X_lp1		; V-Pipe
	mov	al,[esi]		; U-Pipe Cache Stall? 
	mov	ah,[esi+4]		; V-Pipe
	mov	[edi],ax		; U-Pipe


	pop	esi
	inc	esi
	pop	eax
	shl	ah,1
	cmp	ah,10h
	jne	@Sclp

	mov	edx,03c4h		; Select plane 1 again. (TEXT screen needs this)
	mov	eax,0102h
	out	dx,ax			
	ret

CopyXmodeLine endp



;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : CopyScreen                                    *
;         *   Function: Copy over the virtual buffer to the screen    *
;         *                                                           *
;         *   In   : Screen = Buffer address                          *
;         *   Out  : none                                             *
;         *                                                           *
;         *************************************************************
;


	Public	ClearScreen
ClearScreen Proc   C USES esi edi ecx

        mov     edi, Screen
        mov     ecx, (320*50)/4  ;XYsize/4
        mov     eax, 0

@loop2: mov     [edi],eax
        add     edi,4
        dec     ecx
        jne     @loop2
        ret

ClearScreen endp





;************************************************************
;                                                           *
;   Name    :                                               *
;   Function:                                               *
;                                                           *
;   In   :                                                  *
;   Out  :                                                  *
;                                                           *
;************************************************************


     	Public	PrintScreen
DoCursor Proc C USES esi edi eax edx ebx ecx 
	push	ebp

        test  FlashCount,010h               ; check if I have to draw or not..
        je    NoDraw


	; No cursor in Multi coloured mode
	mov	ebp,Memory
	xor	eax,eax
	mov	ah,[ebp+0ff0ch]
	mov	al,[ebp+0ff0dh]
	and	ah,3
	cmp	eax,1000
	ja	NoDraw
	mov	edi,[CharAddress+eax*4]		; get character screen
	add	edi,Screen
	add	edi,20
	add	edi,20*368

	mov	ch,8
Ylp:	
	mov	eax,0
	mov	[edi],eax
	mov	[edi+4],eax

	add	edi,Xsize
	dec	ch
	jne	Ylp

NoDraw:	pop	ebp
	ret


DoCursor	endp


;************************************************************
;                                                           *
;   Name    :                                               *
;   Function:                                               *
;                                                           *
;   In   :                                                  *
;   Out  :                                                  *
;                                                           *
;************************************************************

	Public	here
     	Public	PrintScreen
	Public	DoScroll
	Public	RasterLoop
PrintScreen Proc C USES esi edi eax edx ebx ecx \
		 lineindex:dword, index:dword, BitMapoffset:dword

	push	ebp

	mov	ecx,index
	mov	edi,Screen				; BitMap Screen memory
	add	edi,20
	add	edi,lineindex
	mov	esi,Memory
	add	esi,BitMapoffset

	mov	ebp,pScreenDataAddress		; get pointer to raster data...
	mov	bh,[ebp+col1]
	mov	colour2,bh
	mov	bh,[ebp+col2]
	mov	colour3,bh
	mov	ah,[ebp+col0]		
	mov	colour0,ah
	mov	ah,[ebp+col1]		
	mov	colour1,ah
	mov	ah,[ebp+col4]			; border
	mov	colour4,ah

	mov	eax,[ebp+blank]
	and	eax,010h
	jz	NOSCREEN
	
	mov	eax,[ebp+bmm]
	test	eax,eax
	je	NotBitMapMode
	add	esi,[ebp+BitMap]			; get bitmap address
	;add	esi,Memory
	jmp	RenderBitMap


NotBitMapMode:
	mov	ebp,pScreenDataAddress		; get pointer to raster data...
	mov	eax,[ebp+multicol]
	mov	mcm,eax
	mov	eax,[ebp+ScrollX]
	mov	xscr,eax
	and	eax,7
	add	edi,eax			; no scroll just now..
	;mov	eax,[ebp+blank]
	mov	esi,[ebp+ScreenAddress]	; get screen address from structure
	;and	eax,010h
	;jz	NOSCREEN
	mov	eax,[ebp+Invert]		; get charset address from raster data
	mov	inv,eax
	mov	edx,[ebp+CharSet]		; get charset address from raster data

	mov	ah,colour0
	mov	multitable,ah
	mov	ah,colour2
	mov	multitable+1,ah
	mov	ah,colour3
	mov	multitable+2,ah
	mov	ah,colour4
	mov	multitable+3,ah


	add	ebp,size(tScreenInfo)
	mov	ScrData,ebp
	mov	ebp,40

;
; This Section is normal character mode. No MCM, or ECM etc.. plain..
;
	mov	esi,0
RasterLoop:
	;xor	eax,eax
	;mov	eax,ScreenIndexArray[ecx*4]	; get actual screen index..
	;mov	bh,byte ptr [esi+eax]		; get foreground colour data
	;mov	al,byte ptr [0400h+esi+eax]	; get 1st raster line of screen data(actual character number!)
	
	mov	bh,byte ptr CharAttribute[esi]
	mov	al,byte ptr CharNumber[esi]
	inc	esi

	mov	bl,byte ptr mcm
	cmp	bl,050h				; ECM + MCM? black out screen (not borders)
	je	BlackScreen

	test	bl,010h				; mcm active?
	je	SkipMCM_loop			; if not, ignore!
	test	bh,8					; OR, check character, and see if
	jne	MCM_loop				; its SELCETED mcm.
SkipMCM_loop:
	test	bl,040h				; ECM active?
	jne	DOECM_loop

        
	and	eax,0ffh
	cmp	inv,128
	je	@skipin
	cmp	al,128
	jae	inverloop
@skipin:
	mov	al,byte ptr [edx+eax*8]		; get first line of character dta..
	mov	ah,colour0
	test	al,al
	je	BlankByte

        ; FLASH!
        test  bh,080h                       ; FLASH active?
        je    @NoFlash
        and   bh,127
        test  FlashCount,010h               ; check if I have to draw or not..
        je    BlankByte
@NoFlash:

	mov	bl,8
al_lp:	rol	al,1
	jnc	wipeit
	mov	[edi],bh
	jmp	nextone
wipeit:	
	mov	[edi],ah
nextone:
	inc	edi
	dec	bl
	jnz	al_lp

	inc	ecx
	dec	ebp
	jnz	RasterLoop

	jmp	DoScroll

BlankByte:
	mov	al,ah
	mov	bx,ax
	shl	eax,16
	mov	ax,bx

	mov	[edi],eax
	mov	[edi+4],eax

	add	edi,8
	inc	ecx
	dec	ebp
	jnz	RasterLoop

	jmp	DoScroll


;
; ECM character
;
DoECM_loop:
	mov	bl,al
	and	al,03fh				; get actual character number
	and	bh,07fh				; get FOREground colour
	shr	bl,6					; get colour index
	mov	multitable+1,bh			; foreground colour
	and	ebx,3
	add	ebx,Memory

	mov	bl,byte ptr [0ff15h+ebx]	; get background colour
	mov	bh,[multitable+1]				; get foreground colour

	and	eax,0ffh				
@ECMskipin:
	mov	al,byte ptr [edx+eax*8]			; get first line of character dta..
	mov	ah,8
ECMal_lp:	
	rol	al,1
	jnc	ECMwipeit
	mov	[edi],bh	; foreground
	jmp	ECMnextone
ECMwipeit:	
	mov	[edi],bl	; background
ECMnextone:
	inc	edi
	dec	ah
	jnz	ECMal_lp

	inc	ecx
	dec	ebp
	jnz	RasterLoop

	jmp	DoScroll

	
;
; character inverted loop!
;
inverloop:
	and	al,127
	mov	al,byte ptr [edx+eax*8]		; get first line of character dta..
	mov	ah,colour0

        ; FLASH!
        test  bh,080h                       ; FLASH active?
        je    @NoFlash2
        and   bh,127
        test  FlashCount,010h               ; check if I have to draw or not..
        jne   @NoFlash2
        mov   ah,bh
        jmp   BlankByte
@NoFlash2:

	mov	bl,8
al_lp2:	rol	al,1
	jnc	wipeit2
	mov	[edi],ah
	jmp	nextone2
wipeit2:
	mov	[edi],bh
nextone2:
	inc	edi
	dec	bl
	jnz	al_lp2

	inc	ecx
	dec	ebp
	jnz	RasterLoop

	jmp	DoScroll




;
; a multi coloured character!
;
MCM_loop:
	and	eax,0ffh
	and	bh,077h				; get rid of MCM bit.
@skipin3:
	mov	al,byte ptr [edx+eax*8]		; get first line of character dta..
        mov	multitable+3,bh
	test	al,al
	je	WipeByte

	xor	ebx,ebx
	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi],ah
	mov	[edi+1],ah

	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi+2],ah
	mov	[edi+3],ah
	
	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi+4],ah
	mov	[edi+5],ah

	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi+6],ah
	mov	[edi+7],ah

	add	edi,8
	inc	ecx
	dec	ebp
	jnz	RasterLoop
	jmp	DoScroll
WipeByte:
	mov	al,multitable		; get colour 0
	mov	ah,al
	mov	bx,ax
	shl	eax,16
	mov	ax,bx

	mov	[edi],eax
	mov	[edi+4],eax
	add	edi,8

	inc	ecx
	dec	ebp
	jnz	RasterLoop
	jmp	DoScroll

;
; When ECM and MCM are on, screen is BLACK! (not borders)
;
BlackScreen:
	xor	eax,eax
	mov	ebx,20
@BLSClp:
	mov	[edi],eax
	mov	[edi+4],eax
	mov	[edi+8],eax
	mov	[edi+12],eax
	add	edi,16
	dec	ebx
	jne	@BLSClp
	jmp	DoScroll
	
	
;
; This section is used when the screen is blanked!
;
NOSCREEN:
	mov	dl,colour4
	mov	dh,colour4
	mov	ax,dx
	shl	edx,16
	mov	dx,ax

	sub	edi,20
	mov	ecx,360/4
NOSCREENLOOP:
	mov	[edi],edx
	add	edi,4
	dec	ecx
	jne	NOSCREENLOOP
	pop	ebp
	ret


;
; Render a BITMAP screen
;
RenderBitMap:

        mov	eax,[ebp+ScrollX]
	mov	xscr,eax
	and	eax,7
	add	edi,eax			; no scroll just now..

	mov	eax,[ebp+multicol]
	test	eax,eax
	jne	DoMultiColorBitMap

	mov	dh,40			; X loop
BMlp1:	
	push	edx
	mov	edx,[ebp+ScreenAddress]	; get screen address from structure
	mov	eax,ScreenIndexArray[ecx*4]	; get actual screen index..
	mov	bl,byte ptr [edx+eax]		; lum (both colours)
	mov	bh,byte ptr [0400h+edx+eax]	; col (both colours)

	mov	al,bl			; get LUMINANCE  ($0000+charscreen - low nibble)
	mov	ah,bh			; get COLOUR     ($0400+charscreen - low nibble)
	and	ax,00ff0h		; get lum into upper nibble
	or	ah,al			; GOT 1st colour in AH!

	shr	bh,4
	shl	bl,4
	or	bl,bh			; get colour 2
	mov	bh,ah
	pop	edx

        and   bx,07f7fh

	mov	dl,8			; pixel loop
	mov	al,[esi]		; get pixel
	add	esi,8

BMlp2:  rol	al,1
	jnc	clearit
	mov	[edi],bl
	jmp	noset
clearit:
	mov	[edi],bh
noset:
	inc	edi
	dec	dl
	jne	BMlp2

	inc	ecx
	dec	dh
	jne	BMlp1
	jmp	DoScroll


here:
DoMultiColorBitMap:
	xor	eax,eax
	mov	edx,[ebp+ScreenAddress]	; get screen address from structure
	mov	eax,ScreenIndexArray[ecx*4]	; get actual screen index..
	mov	bh,byte ptr [0400h+edx+eax]		; get foreground colour data

	mov	ah,colour0
        and   ah,07fh
        mov	multitable,ah
	mov	ah,colour1
        and   ah,07fh
	mov	multitable+3,ah

	mov	edx,40
BM_RasLoop:
	push	edx
	mov	edx,[ebp+ScreenAddress]	; get screen address from structure
	mov	eax,ScreenIndexArray[ecx*4]	; get actual screen index..
	mov	bl,byte ptr [edx+eax]		; lum (both colours)
	mov	bh,byte ptr [0400h+edx+eax]	; col (both colours)

	mov	al,bl			; get LUMINANCE  ($0000+charscreen - low nibble)
	mov	ah,bh			; get COLOUR     ($0400+charscreen - low nibble)
	and	ax,00ff0h		; get lum into upper nibble
	or	ah,al			; GOT 1st colour in AH!

	shr	bh,4
	shl	bl,4
	or	bl,bh			; get colour 2

        and   ah,07fh
        and   bl,07fh
	mov	multitable+2,ah
	mov	multitable+1,bl
	pop	edx


	mov	al,[esi]
	add	esi,8
	test	al,al
	je	WipeData

	xor	ebx,ebx
	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi],ah
	mov	[edi+1],ah

	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi+2],ah
	mov	[edi+3],ah
	
	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi+4],ah
	mov	[edi+5],ah

	rol	al,2
	mov	bl,al
	and	bl,3
	mov	ah,[multitable+ebx]
	mov	[edi+6],ah
	mov	[edi+7],ah

	add	edi,8
	inc	ecx
	dec	edx
	jnz	BM_RasLoop

	jmp	DoScroll
	Public	WipeData
WipeData:
	mov	al,multitable		; get colour 0
	mov	ah,multitable
        and   eax,07f7fh
        mov	bx,ax
	shl	eax,16
	mov	ax,bx

	mov	[edi],eax
	mov	[edi+4],eax

	add	edi,8
	inc	ecx
	dec	edx
	jnz	BM_RasLoop

	jmp	DoScroll

DoScroll:				; Draw boarders... (real borders)
; Do cursor here!


; End cursor!

	mov	dl,colour4
	mov	dh,colour4
	mov	ax,dx
	shl	edx,16
	mov	dx,ax

	mov	eax,xscr
	and	eax,7
	sub	edi,eax

	mov	[edi],edx
	mov	[edi+4],edx
	mov	[edi+8],edx
	mov	[edi+12],edx
	mov	[edi+16],edx
	mov	[edi-320-20],edx
	mov	[edi-320-16],edx
	mov	[edi-320-12],edx
	mov	[edi-320-8],edx
	mov	[edi-320-4],edx


	mov	eax,xscr
	and	eax,8
	test	eax,eax
	jne	Skipborder

	mov	dl,colour4
	mov	dh,colour4
	mov	ax,dx
	shl	edx,16
	mov	dx,ax

	mov	[edi-4],edx
	mov	[edi-8],edx
	mov	[edi-320+4],edx
	mov	[edi-320],edx

Skipborder:
	pop	ebp
	ret

PrintScreen endp

;************************************************************
;                                                           *
;   Name    :                                               *
;   Function:                                               *
;                                                           *
;   In   :                                                  *
;   Out  :                                                  *
;                                                           *
;************************************************************
initgfx	Proc  C 
	push	ebp
	mov	ebp,esp
	add	ebp,08H
	push	eax
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi

	cld
	cli
	mov	ax,00013H
	int	010H

	mov   eax,dword ptr ss:[ebp]
	cmp	eax,02H
	jb	_igfx3
	cmp	eax,05H
	ja	_igfx3

	mov  	dx,003c4H
	mov  	ax,00100H
	out  	dx,al
	inc  	dx
	mov  	al,ah
	out  	dx,al
	mov  	dx,003c2H
	mov  	al,0e7H
	out  	dx,al
	mov  	dx,003c4H
	mov  	ax,00300H
	out  	dx,al
	inc  	dx
	mov  	al,ah
	out  	dx,al
	mov  	dx,003d4H
	mov  	al,011H
	out  	dx,al
	inc  	dx
	in   	al,dx
	and  	al,07fH
	mov  	ah,al
	dec  	dx
	mov  	al,011H
	out  	dx,al
	inc  	dx
	mov	al,ah
	out  	dx,al

	mov   eax,dword ptr ss:[ebp]
	mov	esi,offset _vgaRegs384x282Scan
	cmp	eax,05H
	je	short _igfx0
	mov	esi,offset _vgaRegs384x282
	cmp	eax,04H
	je	short _igfx0
	mov	esi,offset _vgaRegs384x246
	cmp	eax,03H
	je	short _igfx0
	mov	esi,offset _vgaRegs368x240
	cmp	eax,02H
	je	short _igfx0

_igfx0:
	lodsw
	movzx 	ecx,ax
	test  	cx,cx
	je   	short _igfx2
	lodsw
	mov  	dx,ax

_igfx1:
	lodsw
	out  	dx,al
	inc  	dx
	mov  	al,ah
	out  	dx,al
	dec  	dx
	loop 	short _igfx1
	jmp  	short _igfx0

_igfx2:
	mov  	dx,003daH
	in   	al,dx
	mov  	dx,003c0H
	mov  	ax,04130H
	out  	dx,al
	mov  	al,ah
	out  	dx,al
	mov  	dx,003daH
	in   	al,dx
	mov  	dx,003c0H
	mov  	ax,00033H
	out  	dx,al
	mov  	al,ah
	out  	dx,al
	mov  	dx,003daH
	in   	al,dx
	mov  	dx,003c0H
	mov  	ax,00031H
	out  	dx,al
	mov  	al,ah
	out  	dx,al

_igfx3:
	lea  	esi,_rgbColors
	mov  	ecx,00010H

_igfx4:
	mov  	dx,003c8H
	outsb
	mov  	dx,003c9H
	outsb
	outsb
	outsb
	loop	short _igfx4
	sti
	;call	_enablerealmem
	pop	edi
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	pop	ebp
	ret
initgfx	endp

restoregfx	Proc C
	push	eax
	mov  	ax,00003H
	INT	010H
	;call	_disablerealmem
	pop	eax
	ret
restoregfx	endp


_vgaRegs384x282Scan	label	word
	dw	00012H,003d4H,06e00H,05f01H,05f02H,08703H,06404H,08005H
	dw	04306H,01f07H,00008H,06009H,02a10H,0ac11H,01912H,03013H
	dw	00014H,02715H,03a16H,0e317H
	dw	00002H,003c4H,00101H,00604H
	dw	00002H,003ceH,04005H,00506H
	dw	00000H
_vgaRegs384x282	label	word
	dw	00012H,003d4H,06e00H,05f01H,05f02H,08703H,06404H,08005H
	dw	06206H,0f007H,00008H,06109H,03710H,08911H,03312H,03013H
	dw	00014H,03c15H,05c16H,0e317H
	dw	00002H,003c4H,00101H,00604H
	dw	00002H,003ceH,04005H,00506H
	dw	00000H
_vgaRegs384x246	label	word
	dw	00012H,003d4H,06e00H,05f01H,05f02H,08703H,06404H,08005H
	dw	00d06H,03e07H,00008H,04109H,0f110H,0ac11H,0ec12H,03013H
	dw	00014H,0eb15H,00616H,0e317H
	dw	00002H,003c4H,00101H,00604H
	dw	00002H,003ceH,04005H,00506H
	dw	00000H
_vgaRegs368x240	label	word
	dw	00012H,003d4H,06e00H,05b01H,05c02H,08703H,06104H,08005H
	dw	00d06H,03e07H,00008H,04109H,0ea10H,0ac11H,0df12H,02e13H
	dw	00014H,0eb15H,00616H,0e317H
	dw	00002H,003c4H,00101H,00604H
	dw	00002H,003ceH,04005H,00506H
	dw	00000H
_rgbColors	label	byte
	db	000H,008H,008H,008H
	db	001H,03fH,03fH,03fH
	db	002H,038H,010H,010H
	db	003H,018H,03fH,03fH
	db	004H,038H,018H,038H
	db	005H,010H,038H,010H
	db	006H,010H,010H,038H
	db	007H,03fH,03fH,010H
	db	008H,038H,028H,010H
	db	009H,027H,01dH,012H
	db	00aH,03fH,028H,028H
	db	00bH,015H,015H,015H
	db	00cH,022H,022H,022H
	db	00dH,028H,03fH,028H
	db	00eH,028H,028H,03fH
	db	00fH,030H,030H,030H
; OLD COLORS
	db	000H,000H,000H,000H
	db	001H,03fH,03fH,03fH
	db	002H,03fH,008H,008H
	db	003H,008H,03fH,03fH
	db	004H,03fH,008H,03fH
	db	005H,008H,03fH,008H
	db	006H,008H,008H,03fH
	db	007H,03fH,03fH,008H
	db	008H,03fH,020H,008H
	db	009H,01fH,015H,00aH
	db	00aH,03fH,020H,030H
	db	00bH,010H,010H,010H
	db	00cH,020H,020H,020H
	db	00dH,028H,03fH,028H
	db	00eH,028H,028H,03fH
	db	00fH,030H,030H,030H

end


















