;******************************************************************************
;									 		    
;									  																	 *
;									  
;			 Windows system drawing
;											 
;											     
;		  Copyright Mike Dailly 1995-96
;                                                                          
;                                                                          
;                                                                          
;******************************************************************************

wcstack	equ	1

	.486

IFDEF WCSTACK
	extrn  mouse:word
	extrn  moved:word
	extrn  xx:word
	extrn  yy:word
	extrn  but:word
;	extrn  wx1:dword
;	extrn  wy1:dword
;	extrn  wx2:dword
;	extrn  wy2:dword
	.MODEL  FLAT
ENDIF

IFDEF	WCREG
	.MODEL  FLAT,C
ENDIF


twindow  struct
wx			word	?
wy			word	?
wxsize			word	?
wysize			word	?
wmaxxsize		word	?
wmaxysize		word	?
wclipx1			word	?
wclipy1			word	?
wclipx2			word	?
wclipy2			word	?
wminx  			word	?
wminy  			word	?
wmaxx  			word	?
wmaxy  			word	?
woffsetx		dword	?
woffsety		dword	?
wvxsize			dword	?
wvysize			dword	?
wvscrollx		dword	?
wvscrolly		dword	?
wflags			dword	?
woptions		dword	?
wMenuID			dword ?
wWindowColour		byte	?
wPenColour		byte	?
wDrawCol1		byte	?
wDrawCol2		byte	?
wDrawCol3		byte	?
wDrawCol4		byte	?
wDrawCol5		byte	?
wBitMap			dword	?
wBackDrop		dword	?
wpFont			dword	?
wpFirstMenu  		dword	?
wpFirstGadget		dword	?
wpLastGadget		dword	?
wpParentWindow	dword	?
wpFirstChildWindow	dword	?
wpLastChildWindow  	dword	?
wpNextWindow		dword	?
wpLastWindow		dword	?
twindow	ends


INT_ST  struct
R_EDI   dword   0
R_ESI   dword   0
R_EBP   dword   0
R_reserved      dword   0
R_EBX   dword   0
R_EDX   dword   0
R_ECX   dword   0
R_EAX   dword   0
R_Flags word    0
R_ES    word    0
R_DS    word    0
R_FS    word    0
R_GS    word    0
R_IP    word    0
R_CS    word    0
R_SP    word    0
R_SS    word    0
INT_ST  ENDS



	.DATA
IFDEF WCREG
	extrn  mouse:word
	extrn  moved:word
	extrn  xx:word
	extrn  yy:word
	extrn  but:word
;	extrn  wx1:dword
;	extrn  wy1:dword
;	extrn  wx2:dword
;	extrn  wy2:dword
ENDIF

	
Temp    dword   0
Ints	INT_ST	<>

;	public	FontData
;	public	GadData
;FontData	dword		0 ;FontDataAdd
;GadData	dword		0 ;GadDataAdd

xmod	dword	?
scrmod	dword	?
cx1	dword	?
cy1	dword	?
cx2	dword	?
cy2	dword	?
xsi	dword	?
BitMap	dword	?


	; include graphics data

	include	graphics\font.s
	include	graphics\dmawind.s
	public	FontData
	public	GadData


          .CODE


;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : PrintBlock                                    *
;         *   Function: Print a sprite at X,Y of size sx,sy with shape*
;         *             DATA                                          *
;         *                                                           *
;         *   In   : Screen = Buffer address                          *
;         *   Out  : none                                             *
;         *                                                           *
;         *************************************************************
;

	Public	SysSprite
SysSprite Proc  C USES esi edi ecx eax edx ebx \
                pWindow:dword,data:dword, x1:dword,y1:dword, xs:dword,ys:dword, realxsize:dword
                ;local	xmod:dword,scrmod:dword
                ;local	cx1:dword,cy1:dword,cx2:dword,cy2:dword,xsi:dword
                ;local	BitMap:dword

        mov	eax,pWindow			; copy CLIP details
        mov	ebx,0
        mov	bx,wclipx1[eax]	
        mov	cx1,ebx
        mov	bx,wclipy1[eax]	
        mov	cy1,ebx
        mov	bx,wclipx2[eax]	
        mov	cx2,ebx
        mov	bx,wclipy2[eax]	
        mov	cy2,ebx

	mov	ebx,cx1		; window off screen? (y1>y2 or x1>x2)
	cmp	ebx,cx2
	jge	@quitout
	mov	ebx,cy1
	cmp	ebx,cy2
	jge	@quitout
	
	
	mov	bx,wmaxxsize[eax]		; store actual window size xsize
        mov	xsi,ebx
        mov	ebx,wBitMap[eax]		; store bit map base address
        mov	BitMap,ebx

	
	mov	esi,data
        mov	ebx,y1
        cmp	ebx,cy1 		; off top?
        jge	@_sbOver0
        sub	ebx,cy1
        neg	ebx
        mov	eax,ebx
        mul	realxsize
        sub	ys,ebx  		; lines to do
        mov	ebx,eax
        add	esi,ebx
        mov	ebx,cy1
@_sbOver0:
        mov	eax,ys 		; get bottom y cord
	add	eax,ebx
        cmp	eax,cy2 		; off bottom?
        jle	@_sbDoX
        sub	eax,cy2		; get count off bottom
	neg	eax
        add	ys,eax
@_sbDoX:
        mov	ecx,realxsize	; work out sprite modulo
	sub	ecx,xs
	mov	xmod,ecx
        mov	ecx,xsi		; get screen modulo
        mov	scrmod,ecx
	mov	eax,x1

        cmp	eax,cx1
        jge	@_sbDoBigX
        sub	eax,cx1
        add	xs,eax          ; Less "eax" pixels off left side
        sub	xmod,eax        ; SUB NEG number (makes pos value)
        sub	esi,eax 
        mov	eax,cx1
        mov	x1,eax          ; make new X cord

@_sbDoBigX:
	mov	ecx,xs	    ; get X size+xcord
	add	ecx,x1	    ; get RIGHTMOST x cord	
	mov	eax,cx2	    ; off window right?
	cmp	eax,ecx
        jge	@_sbNope
        sub	ecx,eax
        sub	xs,ecx
        add	xmod,ecx

        
@_sbNope:
        mov	ecx,xs		; work out screen modulo
        sub	scrmod,ecx


        mov	eax, xs
        cmp	eax, 1
        jl	@_sbNone_left
        mov	eax, ys
        cmp	eax,1
        jl	@_sbNone_left

        mov	eax, ebx
        mov	edi,BitMap
        mul	xsi
        add	eax, x1
        add	edi,eax


        mov	ecx, ys

@_sbsploop2:   
        mov	ebx, xs
@_sbspLoop:    
        mov	al,[esi]
	inc	esi
	and	al,al
	jz	@_Skip
	mov	[edi],al
@_Skip:
	inc	edi
        dec	ebx
        jne	@_sbspLoop

        add	edi,scrmod
        add	esi,xmod
        dec	ecx
        jne	@_sbspLoop2
@_sbNone_Left:
@quitout:
	ret

SysSprite endp



;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : PrintBlock                                    *
;         *   Function: Print a sprite at X,Y of size sx,sy with shape*
;         *             DATA                                          *
;         *                                                           *
;         *   In   : Screen = Buffer address                          *
;         *   Out  : none                                             *
;         *                                                           *
;         *************************************************************
;


	Public	SysBlock
SysBlock Proc        C USES esi edi ecx eax edx ebx \
                pWindow:dword,data:dword, x1:dword,y1:dword, xs:dword,ys:dword, realxsize:dword
;                local	xmod:dword,scrmod:dword
;                local	cx1:dword,cy1:dword,cx2:dword,cy2:dword,xsi:dword
;                local	BitMap:dword

        mov	eax,pWindow			; copy CLIP details
        mov	ebx,0
        mov	bx,wclipx1[eax]	
        mov	cx1,ebx
        mov	bx,wclipy1[eax]	
        mov	cy1,ebx
        mov	bx,wclipx2[eax]	
        mov	cx2,ebx
        mov	bx,wclipy2[eax]	
        mov	cy2,ebx

	mov	ebx,cx1		; window off screen? (y1>y2 or x1>x2)
	cmp	ebx,cx2
	jge	@quitout2
	mov	ebx,cy1
	cmp	ebx,cy2
	jge	@quitout2
	
	
	mov	bx,wmaxxsize[eax]		; store xsize
        mov	xsi,ebx
        mov	ebx,wBitMap[eax]		; store bit map base address
        mov	BitMap,ebx

        mov	esi,data

        mov	ebx,y1
        cmp	ebx,cy1 		; off top?
        jge	@sbOver0
        sub	ebx,cy1
        neg	ebx
        mov	eax,ebx
        mul	realxsize
        sub	ys,ebx  		; lines to do
        mov	ebx,eax
        add	esi,ebx
        mov	ebx,cy1
@sbOver0:
        mov	eax,ys 		; get bottom y cord
	add	eax,ebx
        cmp	eax,cy2 		; off bottom?
        jle	@sbDoX
        sub	eax,cy2		; get count off bottom
	neg	eax
        add	ys,eax
@sbDoX:
        mov	ecx,realxsize	; work out sprite modulo
	sub	ecx,xs
	mov	xmod,ecx
        mov	ecx,xsi		; get screen modulo
        mov	scrmod,ecx
	mov	eax,x1

        cmp	eax,cx1
        jge	@sbDoBigX
        sub	eax,cx1
        add	xs,eax          ; Less "eax" pixels off left side
        sub	xmod,eax        ; SUB NEG number (makes pos value)
        sub	esi,eax 
        mov	eax,cx1
        mov	x1,eax          ; make new X cord

@sbDoBigX:
	mov	ecx,xs	    ; get X size+xcord
	add	ecx,x1	    ; get RIGHTMOST x cord	
	mov	eax,cx2	    ; off window right?
	cmp	eax,ecx
        jge	@sbNope
        sub	ecx,eax
        sub	xs,ecx
        add	xmod,ecx

        
@sbNope:
        mov	ecx,xs		; work out screen modulo
        sub	scrmod,ecx
	

        mov	eax, xs
        cmp	eax, 1
        jl	@sbNone_left
        mov	eax, ys
        cmp	eax,1
        jl	@sbNone_left

        mov	eax, ebx
        mov	edi,BitMap
        mul	xsi
        add	eax, x1
        add	edi,eax


        mov	ecx, ys

@sbsploop2:                           ; Write LONG's first
        mov	ebx, xs
        push  ebx
        shr   ebx,2
        test  ebx,ebx
        je    @Skipit1
@sbspLoop:    
        mov	eax,[esi]
        add	esi,4
        mov	[edi],eax
        add	edi,4
        dec	ebx
        jne	@sbspLoop

@SkipIt1:
        pop   ebx                     ; then the left over bytes...
        and   ebx,3
        test  ebx,ebx
        je    @Skip2
@sbspLoop_2:    
        mov	al,[esi]
        inc	esi
        mov	[edi],al
        inc	edi
        dec	ebx
        jne	@sbspLoop_2
@Skip2:

        add	edi,scrmod
        add	esi,xmod
        dec	ecx
        jne	@sbspLoop2
@sbNone_Left:
@quitout2:
        ret

SysBlock endp



;@sbsploop2:   
;        mov	ebx, xs
;@sbspLoop:    
;        mov	al,[esi]
;        inc	esi
;        mov	[edi],al
;        inc	edi
;        dec	ebx
;        jne	@sbspLoop

;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : PrintBlock                                    *
;         *   Function: Print a sprite at X,Y of size sx,sy with shape*
;         *             DATA                                          *
;         *                                                           *
;         *   In   : Screen = Buffer address                          *
;         *   Out  : none                                             *
;         *                                                           *
;         *************************************************************
;

	Public	SysSpriteMono
SysSpriteMono Proc    C USES esi edi ecx eax edx ebx \
                pWindow:dword,data:dword, x1:dword,y1:dword, xs:dword,ys:dword, realxsize:dword, col:byte
                ;local	xmod:dword,scrmod:dword
                ;local	cx1:dword,cy1:dword,cx2:dword,cy2:dword,xsi:dword
                ;local	BitMap:dword

        mov	eax,pWindow			; copy CLIP details
        mov	ebx,0
        mov	bx,wclipx1[eax]	
        mov	cx1,ebx
        mov	bx,wclipy1[eax]	
        mov	cy1,ebx
        mov	bx,wclipx2[eax]	
        mov	cx2,ebx
        mov	bx,wclipy2[eax]	
        mov	cy2,ebx

	mov	ebx,cx1		; window off screen? (y1>y2 or x1>x2)
	cmp	ebx,cx2
	jge	@Mquitout
	mov	ebx,cy1
	cmp	ebx,cy2
	jge	@Mquitout
	
	
	mov	bx,wmaxxsize[eax]		; store actual window size xsize
        mov	xsi,ebx
        mov	ebx,wBitMap[eax]		; store bit map base address
        mov	BitMap,ebx

	
	mov	esi,data
        mov	ebx,y1
        cmp	ebx,cy1 		; off top?
        jge	@M_sbOver0
        sub	ebx,cy1
        neg	ebx
        mov	eax,ebx
        mul	realxsize
        sub	ys,ebx  		; lines to do
        mov	ebx,eax
        add	esi,ebx
        mov	ebx,cy1
@M_sbOver0:
        mov	eax,ys 		; get bottom y cord
	add	eax,ebx
        cmp	eax,cy2 		; off bottom?
        jle	@M_sbDoX
        sub	eax,cy2		; get count off bottom
	neg	eax
        add	ys,eax
@M_sbDoX:
        mov	ecx,realxsize	; work out sprite modulo
	sub	ecx,xs
	mov	xmod,ecx
        mov	ecx,xsi		; get screen modulo
        mov	scrmod,ecx
	mov	eax,x1

        cmp	eax,cx1
        jge	@M_sbDoBigX
        sub	eax,cx1
        add	xs,eax          ; Less "eax" pixels off left side
        sub	xmod,eax        ; SUB NEG number (makes pos value)
        sub	esi,eax 
        mov	eax,cx1
        mov	x1,eax          ; make new X cord

@M_sbDoBigX:
	mov	ecx,xs	    ; get X size+xcord
	add	ecx,x1	    ; get RIGHTMOST x cord	
	mov	eax,cx2	    ; off window right?
	cmp	eax,ecx
        jge	@M_sbNope
        sub	ecx,eax
        sub	xs,ecx
        add	xmod,ecx

        
@M_sbNope:
        mov	ecx,xs		; work out screen modulo
        sub	scrmod,ecx


        mov	eax, xs
        cmp	eax, 1
        jl	@M_sbNone_left
        mov	eax, ys
        cmp	eax,1
        jl	@M_sbNone_left

        mov	eax, ebx
        mov	edi,BitMap
        mul	xsi
        add	eax, x1
        add	edi,eax


        mov	ecx, ys
	mov	dl,  col		; get draw colour

@M_sbsploop2:   
        mov	ebx, xs
@M_sbspLoop:    
        mov	al,[esi]
	inc	esi
	and	al,al
	jz	@M_Skip
	mov	[edi],dl		; store draw colour
@M_Skip:
	inc	edi
        dec	ebx
        jne	@M_sbspLoop

        add	edi,scrmod
        add	esi,xmod
        dec	ecx
        jne	@M_sbspLoop2
@M_sbNone_Left:
@Mquitout:
	ret

SysSpriteMono endp


;********************************************************************************
;
;         *************************************************************
;         *                                                           *
;         *   Name    : PrintBlock                                    *
;         *   Function: Print a sprite at X,Y of size sx,sy with shape*
;         *             DATA                                          *
;         *                                                           *
;         *   In   : Screen = Buffer address                          *
;         *   Out  : none                                             *
;         *                                                           *
;         *************************************************************
;

	Public	SysBlockMono
SysBlockMono Proc        C USES esi edi ecx eax edx ebx \
                pWindow:dword,data:dword, x1:dword,y1:dword, xs:dword,ys:dword, realxsize:dword, fcol:byte, bcol:byte
;                local	xmod:dword,scrmod:dword
;                local	cx1:dword,cy1:dword,cx2:dword,cy2:dword,xsi:dword
;                local	BitMap:dword

        mov	eax,pWindow			; copy CLIP details
        mov	ebx,0
        mov	bx,wclipx1[eax]	
        mov	cx1,ebx
        mov	bx,wclipy1[eax]	
        mov	cy1,ebx
        mov	bx,wclipx2[eax]	
        mov	cx2,ebx
        mov	bx,wclipy2[eax]	
        mov	cy2,ebx

	mov	ebx,cx1		; window off screen? (y1>y2 or x1>x2)
	cmp	ebx,cx2
	jge	@BMquitout2
	mov	ebx,cy1
	cmp	ebx,cy2
	jge	@BMquitout2
	
	
	mov	bx,wmaxxsize[eax]		; store xsize
        mov	xsi,ebx
        mov	ebx,wBitMap[eax]		; store bit map base address
        mov	BitMap,ebx

        mov	esi,data

        mov	ebx,y1
        cmp	ebx,cy1 		; off top?
        jge	@BMsbOver0
        sub	ebx,cy1
        neg	ebx
        mov	eax,ebx
        mul	realxsize
        sub	ys,ebx  		; lines to do
        mov	ebx,eax
        add	esi,ebx
        mov	ebx,cy1
@BMsbOver0:
        mov	eax,ys 		; get bottom y cord
	add	eax,ebx
        cmp	eax,cy2 		; off bottom?
        jle	@BMsbDoX
        sub	eax,cy2		; get count off bottom
	neg	eax
        add	ys,eax
@BMsbDoX:
        mov	ecx,realxsize	; work out sprite modulo
	sub	ecx,xs
	mov	xmod,ecx
        mov	ecx,xsi		; get screen modulo
        mov	scrmod,ecx
	mov	eax,x1

        cmp	eax,cx1
        jge	@BMsbDoBigX
        sub	eax,cx1
        add	xs,eax          ; Less "eax" pixels off left side
        sub	xmod,eax        ; SUB NEG number (makes pos value)
        sub	esi,eax 
        mov	eax,cx1
        mov	x1,eax          ; make new X cord

@BMsbDoBigX:
	mov	ecx,xs	    ; get X size+xcord
	add	ecx,x1	    ; get RIGHTMOST x cord	
	mov	eax,cx2	    ; off window right?
	cmp	eax,ecx
        jge	@BMsbNope
        sub	ecx,eax
        sub	xs,ecx
        add	xmod,ecx

        
@BMsbNope:
        mov	ecx,xs		; work out screen modulo
        sub	scrmod,ecx
	

        mov	eax, xs
        cmp	eax, 1
        jl	@BMsbNone_left
        mov	eax, ys
        cmp	eax,1
        jl	@BMsbNone_left

        mov	eax, ebx
        mov	edi,BitMap
        mul	xsi
        add	eax, x1
        add	edi,eax


        mov	ecx, ys
	mov	dl, fcol
	mov	dh, bcol

@BMsbsploop2:   
        mov	ebx, xs
@BMsbspLoop:    
        mov	al,[esi]
        inc	esi
	and	al,al
	jz	@wipe
        mov	[edi],dl		; store colour
	jmp	@skipwipe
@wipe:
	mov	[edi],dh		; wipe background
@skipwipe:
	inc	edi
        dec	ebx
        jne	@BMsbspLoop

        add	edi,scrmod
        add	esi,xmod
        dec	ecx
        jne	@BMsbspLoop2
@BMsbNone_Left:
@BMquitout2:
        ret

SysBlockMono endp



;;************************************************************
;;                                                           *
;;   Name    :                                               *
;;   Function:                                               *
;;                                                           *
;;   In   :                                                  *
;;   Out  :                                                  *
;;                                                           *
;;************************************************************
;
;
;	Public	SysFillBox
;SysFillBox Proc        C USES esi edi ecx eax edx ebx \
;                pWindow:dword, x1:dword,y1:dword, xs:dword,ys:dword, realxsize:dword, col:byte
;
;
;        mov	eax,pWindow			; copy CLIP details
;        mov	ebx,0
;        mov	bx,wclipx1[eax]	
;        mov	cx1,ebx
;        mov	bx,wclipy1[eax]	
;        mov	cy1,ebx
;        mov	bx,wclipx2[eax]	
;        mov	cx2,ebx
;        mov	bx,wclipy2[eax]	
;        mov	cy2,ebx
;
;	mov	ebx,cx1		; window off screen? (y1>y2 or x1>x2)
;	cmp	ebx,cx2
;	jge	@sfb_quit
;	mov	ebx,cy1
;	cmp	ebx,cy2
;	jge	@sfb_quit
;	
;	
;	mov	bx,wmaxxsize[eax]		; store xsize
;        	mov	xsi,ebx
;        	mov	ebx,wBitMap[eax]		; store bit map base address
;        	mov	BitMap,ebx
;
;        	mov	esi,data
;
;        	mov	ebx,y1
;        	cmp	ebx,cy1 		; off top?
;        	jge	@sfbsbOver0
;        	sub	ebx,cy1
;        	neg	ebx
;        	mov	eax,ebx
;        	mul	realxsize
;        	sub	ys,ebx  		; lines to do
;        	mov	ebx,eax
;        	add	esi,ebx
;        	mov	ebx,cy1
;@sfbsbOver0:
;        mov	eax,ys 		; get bottom y cord
;	add	eax,ebx
;        cmp	eax,cy2 		; off bottom?
;        jle	@sfbsbDoX
;        sub	eax,cy2		; get count off bottom
;	neg	eax
;        add	ys,eax
;@sfbsbDoX:
;        mov	ecx,realxsize	; work out sprite modulo
;	sub	ecx,xs
;	mov	xmod,ecx
;        mov	ecx,xsi		; get screen modulo
;        mov	scrmod,ecx
;	mov	eax,x1
;
;        cmp	eax,cx1
;        jge	@sfbsbDoBigX
;        sub	eax,cx1
;        add	xs,eax          ; Less "eax" pixels off left side
;        sub	xmod,eax        ; SUB NEG number (makes pos value)
;        sub	esi,eax 
;        mov	eax,cx1
;        mov	x1,eax          ; make new X cord
;
;@sfbsbDoBigX:
;	mov	ecx,xs	    ; get X size+xcord
;	add	ecx,x1	    ; get RIGHTMOST x cord	
;	mov	eax,cx2	    ; off window right?
;	cmp	eax,ecx
;        jge	@sfbsbNope
;        sub	ecx,eax
;        sub	xs,ecx
;        add	xmod,ecx
;
;        
;@sfbsbNope:
;        mov	ecx,xs		; work out screen modulo
;        sub	scrmod,ecx
;	
;
;        mov	eax, xs
;        cmp	eax, 1
;        jl	@sfbsbNone_left
;        mov	eax, ys
;        cmp	eax,1
;        jl	@sfbsbNone_left
;
;        mov	eax, ebx
;        mov	edi,BitMap
;        mul	xsi
;        add	eax, x1
;        add	edi,eax
;
;
;        mov	ecx, ys
;	mov	dl, fcol
;	mov	dh, bcol
;
;@sfbsbsploop2:   
;        mov	ebx, xs
;@sfbsbspLoop:    
;        mov	al,[esi]
;        inc	esi
;	and	al,al
;	jz	@wipe
;        mov	[edi],dl		; store colour
;	jmp	@skipwipe
;@wipe:
;	mov	[edi],dh		; wipe background
;@skipwipe:
;	inc	edi
;        dec	ebx
;        jne	@sfbsbspLoop
;
;        add	edi,scrmod
;        add	esi,xmod
;        dec	ecx
;        jne	@sfbsbspLoop2
;
;@sfb_quit:
;	ret
;SysFillBox	endp


	end
